summaryrefslogtreecommitdiffstats
path: root/testing/source/mesa
diff options
context:
space:
mode:
Diffstat (limited to 'testing/source/mesa')
-rw-r--r--testing/source/mesa/README.GIT16
-rwxr-xr-xtesting/source/mesa/get-mesa.sh20
-rwxr-xr-xtesting/source/mesa/mesa.SlackBuild175
-rw-r--r--testing/source/mesa/mesa.url2
-rw-r--r--testing/source/mesa/patches/i915_fragment_shader_disable.patch26
-rw-r--r--testing/source/mesa/patches/mesa-7.9-libdrm-2.4.23-nouveau-api.patch89
-rw-r--r--testing/source/mesa/slack-desc19
7 files changed, 347 insertions, 0 deletions
diff --git a/testing/source/mesa/README.GIT b/testing/source/mesa/README.GIT
new file mode 100644
index 000000000..4e79f374c
--- /dev/null
+++ b/testing/source/mesa/README.GIT
@@ -0,0 +1,16 @@
+Anonymous git Access
+
+ To get the Mesa sources anonymously (read-only):
+
+ 1. Install the git software on your computer if needed.
+
+ 2. Get an initial, local copy of the repository with:
+
+ git clone git://anongit.freedesktop.org/git/mesa/mesa
+
+
+ 3. Later, you can update your tree from the master repository with:
+
+ git pull origin
+
+
diff --git a/testing/source/mesa/get-mesa.sh b/testing/source/mesa/get-mesa.sh
new file mode 100755
index 000000000..253deeb4c
--- /dev/null
+++ b/testing/source/mesa/get-mesa.sh
@@ -0,0 +1,20 @@
+# Pull a stable branch + patches
+BRANCH=7.10
+
+rm -rf mesa
+git clone git://anongit.freedesktop.org/git/mesa/mesa
+# package the source archive and clean up:
+( cd mesa
+ git checkout $BRANCH || exit 1
+)
+HEADISAT="$(cat mesa/.git/packed-refs | grep "refs/remotes/origin/${BRANCH}$" | cut -b1-7)"
+# Cleanup. We're not packing up the whole git repo.
+( cd mesa && find . -type d -name ".git*" -exec rm -rf {} \; 2> /dev/null )
+DATE=$(date +%Y%m%d)
+mv mesa Mesa-${BRANCH}_${HEADISAT}
+tar cf MesaLib-${BRANCH}_${HEADISAT}.tar Mesa-${BRANCH}_${HEADISAT}
+xz -9 MesaLib-${BRANCH}_${HEADISAT}.tar
+rm -rf MesaLib-${BRANCH}_${HEADISAT}
+echo
+echo "Mesa branch $BRANCH with HEAD at $HEADISAT packaged as MesaLib-${BRANCH}_${HEADISAT}.tar.xz"
+echo
diff --git a/testing/source/mesa/mesa.SlackBuild b/testing/source/mesa/mesa.SlackBuild
new file mode 100755
index 000000000..7d612e797
--- /dev/null
+++ b/testing/source/mesa/mesa.SlackBuild
@@ -0,0 +1,175 @@
+#!/bin/sh
+
+# Copyright 2006, 2007, 2008, 2009, 2010, 2011 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PKGNAM=mesa
+VERSION=7.10.2
+DEMOVERS=8.0.1
+BUILD=${BUILD:-1}
+
+NUMJOBS=${NUMJOBS:--j8}
+
+# Be sure this list is up-to-date:
+DRI_DRIVERS="i810,i915,i965,mach64,mga,nouveau,r128,r200,r300,r600,radeon,savage,sis,tdfx,unichrome,swrast"
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-mesa
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf Mesa-${VERSION}
+
+tar xvf $CWD/MesaLib-${VERSION}.tar.?z* || exit 1
+# If MesaLib came from git, we might already have GLUT.
+if [ ! -d Mesa-${VERSION}/src/glut/glx ]; then
+ tar xvf $CWD/MesaGLUT-${VERSION}.tar.?z* || exit 1
+fi
+
+cd Mesa-$VERSION
+
+# Make sure ownerships and permissions are sane:
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# Apply patches from git (and maybe elsewhere):
+# Patches obtained by:
+# git checkout origin/7.9
+# git format-patch 67aeab0b77fb6be864088e69ea74a010b6543fa1..
+if /bin/ls $CWD/patches/*.patch 1> /dev/null 2> /dev/null ; then
+ for patch in $CWD/patches/*.patch ; do
+ patch -p1 < $patch || exit 1 ;
+ done
+fi
+
+# Revert "i915: Enable ARB_fragment_shader by default."
+# https://bugzilla.redhat.com/show_bug.cgi?id=643399
+zcat $CWD/patches/i915_fragment_shader_disable.patch.gz | patch -p1 || exit 1
+
+## Allow Mesa 7.9.x to build against libdrm-2.4.23:
+#zcat $CWD/patches/mesa-7.9-libdrm-2.4.23-nouveau-api.patch.gz | patch -p1 || exit 1
+
+if [ ! -r configure ]; then
+ autoreconf || exit 1
+fi
+
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --sysconfdir=/etc \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/mesa-$VERSION \
+ --with-dri-driverdir=/usr/lib${LIBDIRSUFFIX}/xorg/modules/dri \
+ --with-dri-drivers="$DRI_DRIVERS" \
+ --enable-xcb \
+ --enable-gallium-nouveau \
+ --build=$ARCH-slackware-linux
+
+# --enable-gallium-llvm \
+# --enable-gallium-swrast \
+# --disable-gallium-svga \
+# --disable-gallium-i915 \
+# --disable-gallium-i965 \
+# --disable-gallium-radeon \
+# --disable-gallium-r600 \
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+# Now install the demos
+( cd $TMP
+ rm -rf mesa-demos-$DEMOVERS
+ tar xvf $CWD/mesa-demos-$DEMOVERS.tar.?z* || exit 1
+ cd mesa-demos-$DEMOVERS
+ chown -R root:root .
+ find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+ CFLAGS="$SLKCFLAGS" \
+ ./configure \
+ --prefix=/usr \
+ --build=$ARCH-slackware-linux
+ # Build and install gears and glinfo, as well as a few other demos
+ make -C src/demos gears glinfo
+ make -C src/xdemos \
+ glthreads glxcontexts glxdemo glxgears glxgears_fbconfig \
+ glxheads glxinfo glxpbdemo glxpixmap
+ mkdir -p $PKG/usr/bin
+ cp -a src/demos/{gears,glinfo} $PKG/usr/bin
+ for i in glthreads glxcontexts glxdemo glxgears glxgears_fbconfig \
+ glxheads glxinfo glxpbdemo glxpixmap ; do
+ cp -a src/xdemos/$i $PKG/usr/bin ;
+ done
+)
+
+# Strip binaries:
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+# Compress info files, if any:
+if [ -d $PKG/usr/info ]; then
+ rm -f $PKG/usr/info/dir
+ gzip -9 $PKG/usr/info/*
+fi
+
+mkdir -p $PKG/usr/doc/Mesa-$VERSION/html
+cp -a \
+ docs/COPYING* docs/relnotes-${VERSION}*.html docs/README* docs/GL* \
+ $PKG/usr/doc/Mesa-$VERSION
+cp -a docs/*.html $PKG/usr/doc/Mesa-$VERSION/html
+rm -f $PKG/usr/doc/Mesa-$VERSION/html/relnotes*.html
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/${PKGNAM}-$VERSION-$ARCH-$BUILD.txz
+
diff --git a/testing/source/mesa/mesa.url b/testing/source/mesa/mesa.url
new file mode 100644
index 000000000..3f30cc843
--- /dev/null
+++ b/testing/source/mesa/mesa.url
@@ -0,0 +1,2 @@
+ftp://ftp.freedesktop.org/pub/mesa/
+ftp://ftp.freedesktop.org/pub/mesa/demos/
diff --git a/testing/source/mesa/patches/i915_fragment_shader_disable.patch b/testing/source/mesa/patches/i915_fragment_shader_disable.patch
new file mode 100644
index 000000000..d2aee8e73
--- /dev/null
+++ b/testing/source/mesa/patches/i915_fragment_shader_disable.patch
@@ -0,0 +1,26 @@
+From e5a4106be7c8b87821f6b5d21fec99a402825740 Mon Sep 17 00:00:00 2001
+From: Robert Hooker <sarvatt@ubuntu.com>
+Date: Wed, 8 Sep 2010 12:33:09 -0400
+Subject: [PATCH] Revert "i915: Enable ARB_fragment_shader by default."
+
+This reverts commit a58514cc9c5cc5867f9140700462c5ac5749550d.
+---
+ src/mesa/drivers/dri/intel/intel_screen.c | 2 +-
+ 1 files changed, 1 insertions(+), 1 deletions(-)
+
+diff --git a/src/mesa/drivers/dri/intel/intel_screen.c b/src/mesa/drivers/dri/intel/intel_screen.c
+index 0a542a7..8ae2cd2 100644
+--- a/src/mesa/drivers/dri/intel/intel_screen.c
++++ b/src/mesa/drivers/dri/intel/intel_screen.c
+@@ -70,7 +70,7 @@ PUBLIC const char __driConfigOptions[] =
+ DRI_CONF_DESC(en, "Enable early Z in classic mode (unstable, 945-only).")
+ DRI_CONF_OPT_END
+
+- DRI_CONF_OPT_BEGIN(fragment_shader, bool, true)
++ DRI_CONF_OPT_BEGIN(fragment_shader, bool, false)
+ DRI_CONF_DESC(en, "Enable limited ARB_fragment_shader support on 915/945.")
+ DRI_CONF_OPT_END
+
+--
+1.7.2
+
diff --git a/testing/source/mesa/patches/mesa-7.9-libdrm-2.4.23-nouveau-api.patch b/testing/source/mesa/patches/mesa-7.9-libdrm-2.4.23-nouveau-api.patch
new file mode 100644
index 000000000..d0ce04d26
--- /dev/null
+++ b/testing/source/mesa/patches/mesa-7.9-libdrm-2.4.23-nouveau-api.patch
@@ -0,0 +1,89 @@
+diff -ur a/src/gallium/drivers/nouveau/nouveau_screen.c b/src/gallium/drivers/nouveau/nouveau_screen.c
+--- a/src/gallium/drivers/nouveau/nouveau_screen.c 2010-10-02 00:51:28.000000000 +0200
++++ b/src/gallium/drivers/nouveau/nouveau_screen.c 2010-12-11 18:18:20.527000045 +0100
+@@ -236,7 +236,7 @@
+ int ret;
+
+ ret = nouveau_channel_alloc(dev, 0xbeef0201, 0xbeef0202,
+- &screen->channel);
++ 512*1024, &screen->channel);
+ if (ret)
+ return ret;
+ screen->device = dev;
+diff -ur a/src/mesa/drivers/dri/nouveau/nouveau_context.c b/src/mesa/drivers/dri/nouveau/nouveau_context.c
+--- a/src/mesa/drivers/dri/nouveau/nouveau_context.c 2010-10-05 03:58:00.000000000 +0200
++++ b/src/mesa/drivers/dri/nouveau/nouveau_context.c 2010-12-11 18:18:20.528000045 +0100
+@@ -129,7 +129,7 @@
+
+ /* Allocate a hardware channel. */
+ ret = nouveau_channel_alloc(context_dev(ctx), 0xbeef0201, 0xbeef0202,
+- &nctx->hw.chan);
++ 512*1024, &nctx->hw.chan);
+ if (ret) {
+ nouveau_error("Error initializing the FIFO.\n");
+ return GL_FALSE;
+Nur in b/src/mesa/drivers/dri/nouveau: nouveau_context.c.orig.
+diff -ur a/src/mesa/drivers/dri/nouveau/nouveau_surface.c b/src/mesa/drivers/dri/nouveau/nouveau_surface.c
+--- a/src/mesa/drivers/dri/nouveau/nouveau_surface.c 2010-04-27 23:41:21.000000000 +0200
++++ b/src/mesa/drivers/dri/nouveau/nouveau_surface.c 2010-12-11 18:09:19.750000046 +0100
+@@ -34,8 +34,8 @@
+ unsigned flags, unsigned format,
+ unsigned width, unsigned height)
+ {
+- unsigned tile_mode, cpp = _mesa_get_format_bytes(format);
+- int ret;
++ unsigned tile_mode = 0, tile_flags = 0;
++ int ret, cpp = _mesa_get_format_bytes(format);
+
+ nouveau_bo_ref(NULL, &s->bo);
+
+@@ -51,13 +51,21 @@
+ if (layout == TILED) {
+ s->pitch = align(s->pitch, 256);
+ tile_mode = s->pitch;
++
++ if (cpp == 4)
++ tile_flags = NOUVEAU_BO_TILE_32BPP;
++ else if (cpp == 2)
++ tile_flags = NOUVEAU_BO_TILE_16BPP;
++
++ if (_mesa_get_format_bits(format, GL_DEPTH_BITS))
++ tile_flags |= NOUVEAU_BO_TILE_ZETA;
++
+ } else {
+ s->pitch = align(s->pitch, 64);
+- tile_mode = 0;
+ }
+
+ ret = nouveau_bo_new_tile(context_dev(ctx), flags, 0, s->pitch * height,
+- tile_mode, 0, &s->bo);
++ tile_mode, tile_flags, &s->bo);
+ assert(!ret);
+ }
+
+diff -ur a/src/mesa/drivers/dri/nouveau/nouveau_vbo_t.c b/src/mesa/drivers/dri/nouveau/nouveau_vbo_t.c
+--- a/src/mesa/drivers/dri/nouveau/nouveau_vbo_t.c 2010-10-05 03:58:00.000000000 +0200
++++ b/src/mesa/drivers/dri/nouveau/nouveau_vbo_t.c 2010-12-11 18:18:20.528000045 +0100
+@@ -32,7 +32,7 @@
+
+ /* Arbitrary pushbuf length we can assume we can get with a single
+ * WAIT_RING. */
+-#define PUSHBUF_DWORDS 2048
++#define PUSHBUF_DWORDS 65536
+
+ /* Functions to set up struct nouveau_array_state from something like
+ * a GL array or index buffer. */
+diff -ur a/src/mesa/drivers/dri/nouveau/nv10_state_fb.c b/src/mesa/drivers/dri/nouveau/nv10_state_fb.c
+--- a/src/mesa/drivers/dri/nouveau/nv10_state_fb.c 2010-10-05 03:58:00.000000000 +0200
++++ b/src/mesa/drivers/dri/nouveau/nv10_state_fb.c 2010-12-11 18:15:17.756000046 +0100
+@@ -64,8 +64,8 @@
+
+ if (!nfb->lma_bo || nfb->lma_bo->size != size) {
+ nouveau_bo_ref(NULL, &nfb->lma_bo);
+- nouveau_bo_new(context_dev(ctx), NOUVEAU_BO_VRAM, 0, size,
+- &nfb->lma_bo);
++ nouveau_bo_new_tile(context_dev(ctx), NOUVEAU_BO_VRAM, 0, size,
++ 0, NOUVEAU_BO_TILE_ZETA, &nfb->lma_bo);
+ }
+
+ nouveau_bo_markl(bctx, celsius, NV17TCL_LMA_DEPTH_BUFFER_OFFSET,
diff --git a/testing/source/mesa/slack-desc b/testing/source/mesa/slack-desc
new file mode 100644
index 000000000..113964bd0
--- /dev/null
+++ b/testing/source/mesa/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+mesa: mesa (a 3-D graphics library)
+mesa:
+mesa: Mesa is a 3-D graphics library with an API very similar to that of
+mesa: another well-known 3-D graphics library. :-) The Mesa libraries are
+mesa: used by X to provide both software and hardware accelerated graphics.
+mesa:
+mesa: Mesa was written by Brian Paul.
+mesa:
+mesa:
+mesa:
+mesa: